﻿var Win=function(options){
	this.init=function(){
		if($('#windows').length===0){
			$('body').append('<div id="windowscontainer" style="display:none;position:absolute;z-index:100;"><div id="windows" style="position:absolute;"></div></div>');
		}
		if($('#modalwindows').length===0){
			$('body').append('<div id="modalwindowscontainer" style="display:none;position:absolute;width:100%;height:100%;z-index:101;"><div id="modalwindowsbg" style="width:100%;height:100%;position:absolute;z-index:0;"></div><div id="modalwindows" style="position:absolute;z-index:1;"></div></div>');
		}
		if(options.id){
			if($('#win_'+options.id).length>0){
				$('#win_'+options.id)[0].win.active();
				return;
			}
		}
		options.modal=(!options.modal)?false:true;
		if(window.curWin&&window.curWin.modal)options.modal=true; 
		options.type=(!options.type)?"normal":options.type;
		options.title=(!options.title)?'':options.title;
		options.resizable=(!options.resizable)?true:options.resizable;
		options.draggable=(!options.draggable)?true:options.draggable;
		options.width=(!options.width||options.width==='')?200:options.width-0;
		options.height=(!options.height||options.height==='')?100:options.height-0;
		options.left=(!options.left||options.left==='')?Math.floor(Math.random()*($("body").width()-options.width)):options.left-0; 
		options.top=(!options.top||options.top==='')?Math.floor(Math.random()*($("body").height()-options.height)):options.top-0;
		options.center=(!options.center)?false:options.center;
		if(options.modal)options.center=true;
		if(options.center){
			options.left=($("body").width()-options.width)/2;
			options.top=($("body").height()-options.height)/2;
		}
		if(options.left<0)options.left=0;
		if(options.top<0)options.top=0;
		this.container=document.getElementById('windows');		
		if(options.modal===true){
			this.modal=true;
			this.container=document.getElementById('modalwindows');;
			
		}
		$(this.container.parentNode).show();
		if(!this.container.maxIndex)this.container.maxIndex=-1;
		this.container.maxIndex++;
		this.options=options;
		
		var w=options.width; 
		var h=options.height;
		var l=options.left;
		var t=options.top;

		
		this.fromWin=(options.fromWin)?options.fromWin:window;
		this.fromWinObject=options.fromWinObject;
		this.url=options.url;
		this.title=options.title;

		
		//设置窗体
		this.WIN=creatElement(this.container,"div",(options.id)?"win_"+options.id:"","win "+options.type);
		this.WIN.style.zIndex=this.container.maxIndex;

		//阴影
		this.shadow=creatElement(this.WIN,"div","","shadow");this.shadow.style.cssText="position:absolute;width:100%;height:100%;z-index:0;";
			this.shadow.nw=creatElement(this.shadow,"div","","s-nw");
			this.shadow.n=creatElement(this.shadow,"div","","s-n");
			this.shadow.ne=creatElement(this.shadow,"div","","s-ne");
			this.shadow.w=creatElement(this.shadow,"div","","s-w");
			this.shadow.e=creatElement(this.shadow,"div","","s-e");
			this.shadow.se=creatElement(this.shadow,"div","","s-se");
			this.shadow.s=creatElement(this.shadow,"div","","s-s");
			this.shadow.sw=creatElement(this.shadow,"div","","s-sw");
		this.win=creatElement(this.WIN,"div","","");this.win.style.cssText="position:absolute;top:0px;left:0px;width:100%;height:100%;z-index:1;";

		//边框
		this.nw=creatElement(this.win,"div","","nw");
		this.n=creatElement(this.win,"div","","n");	this.n.innerHTML=this.title;
		this.ne=creatElement(this.win,"div","","ne");
		this.w=creatElement(this.win,"div","","w");
		this.e=creatElement(this.win,"div","","e");
		this.sw=creatElement(this.win,"div","","sw");
		this.s=creatElement(this.win,"div","","s");
		this.se=creatElement(this.win,"div","","se");	
		this.c=creatElement(this.win,"div","","c");
		this.WIN.style.top=t+"px"
		this.WIN.style.left=l+"px";
		this.WIN.style.width=(w+this.e.offsetWidth+this.w.offsetWidth)+"px";
		this.WIN.style.height=(h+this.n.offsetHeight+this.s.offsetHeight)+"px";

	
		//内容
		this.c.style.overflow="hidden";
		this.c.innerHTML='<iframe frameborder="0" width="100%" height="100%" allowtransparency="true" src="'+options.url+'"></iframe>';
		this.content=this.c.firstChild.contentWindow;
		this.content.win=this;this.content.fromWin=this.fromWin;this.content.fromWinObject=this.fromWinObject;this.content.frameWin=this;
		/*var thiswin=this;
		$(this.content).load(function(){
			this.win=thiswin;
			this.fromWin=thiswin.fromWin;
			this.fromWinObject=thiswin.fromWinObject;
		});*/
		
		//蒙板
		this.mask=creatElement(this.win,"div","","mask");
		this.mask.style.cssText="position:absolute;left:0px;top:0px;width:100%;height:100%;background:#000;filter:alpha(opacity=50);opacity:0.01;";

		//按钮
		this.closebutton=creatElement(this.win,"div","","close");
		this.maxbutton=creatElement(this.win,"div","","max");
		if(!options.resizable)$(this.maxbutton).hide();

		//点击按钮、标题条、蒙板、缩放角激活窗口
		this.WIN.win=this.win.win=this.mask.win=this.closebutton.win=this.maxbutton.win=this.n.win=this;
		this.mask.onmousedown=this.n.onmousedown=function(){this.win.active();};
		this.closebutton.onclick=function(){this.win.closeWin();};
		if(options.resizable){
			this.maxbutton.onclick=this.n.ondblclick=function(){this.win.maxWin();};
		}
		

		this.active();
		this.resize(w,h); 
		if(options.autoresize)this.autoresize();
		if(options.maxmize)this.maxWin();


		//允许拖拽缩放
		if(options.draggable){
			$(this.WIN).draggable({
				handle:this.n
				,iframeFix:true
				,zero:true
				,stop:function(){
					if(this.offsetTop>$('body').height())this.style.top=px($('body').height()-50);
					if(this.offsetTop<0)this.style.top="0px";
					if(this.offsetLeft>$('body').width())this.style.left=px($('body').width()-50);
				}
			 });
		}
		if(options.resizable){
			$(this.WIN).resizable({
				minHeight: this.minHeight
				,minWidth: this.minWidth
				,iframeFix:true
				,start:function(){
					$(this.win.mask).show();
				}
				,stop:function(){
					$(this.win.mask).hide();
					this.win.resize();
				}
				,helper:"ui-dummy"
			  });
			}			

	}


	
	this.resize=function(w,h){
	    if(w) this.WIN.style.width=px(w+this.e.offsetWidth+this.w.offsetWidth);
		if(h) this.WIN.style.height=px(h+this.n.offsetHeight+this.s.offsetHeight);
		w=this.WIN.offsetWidth;
		h=this.WIN.offsetHeight; 
		if(this.nw.offsetWidth==w||this.n.offsetHeight==h||this.ne.offsetWidth==w||this.w.offsetWidth==w||this.e.offsetWidth==w||this.sw.offsetWidth==w||this.s.offsetHeight==h||this.se.offsetWidth==w)return false;
	
		sw=w-(this.shadow.offsetLeft*2);
		sh=h-(this.shadow.offsetTop*2);
		$(this.shadow).width(sw).height(sh);
		this.shadow.n.style.top=this.shadow.ne.style.top=this.shadow.nw.style.top="0px";
		this.shadow.n.style.width=px(sw-this.shadow.ne.offsetWidth-this.shadow.nw.offsetWidth);
		this.shadow.n.style.left=px(this.shadow.nw.offsetWidth);
		this.shadow.ne.style.right=this.shadow.e.style.right=this.shadow.se.style.right="0px";
		this.shadow.e.style.height=px(sh-this.shadow.ne.offsetHeight-this.shadow.se.offsetHeight);
		this.shadow.e.style.top=px(this.shadow.ne.offsetHeight);
		this.shadow.w.style.height=px(sh-this.shadow.nw.offsetHeight-this.shadow.sw.offsetHeight);
		this.shadow.w.style.top=px(this.shadow.nw.offsetHeight);
		this.shadow.s.style.width=px(sw-this.shadow.se.offsetWidth-this.shadow.sw.offsetWidth);
		this.shadow.s.style.bottom=this.shadow.se.style.bottom=this.shadow.sw.style.bottom="0px";
		this.shadow.s.style.right=px(this.shadow.se.offsetWidth);
		
		this.n.style.left=px(this.nw.offsetWidth);
		this.n.style.width=px(w-this.nw.offsetWidth-this.ne.offsetWidth);
		this.ne.style.left=px(this.nw.offsetWidth+this.n.offsetWidth);
		this.w.style.top=px(this.nw.offsetHeight);
		this.w.style.height=px(h-this.nw.offsetHeight-this.sw.offsetHeight);
		this.c.style.left=px(this.w.offsetWidth);
		this.c.style.top=px(this.n.offsetHeight);
		this.c.style.width=px(w-this.w.offsetWidth-this.e.offsetWidth);
		this.c.style.height=px(h-this.n.offsetHeight-this.s.offsetHeight);			
		this.e.style.top=px(this.ne.offsetHeight);
		this.e.style.left=px(this.w.offsetWidth+this.c.offsetWidth);
		this.e.style.height=px(h-this.ne.offsetHeight-this.se.offsetHeight);
		this.sw.style.top=px(this.n.offsetHeight+this.w.offsetHeight);
		this.s.style.left=px(this.sw.offsetWidth);
		this.s.style.top=px(this.n.offsetHeight+this.c.offsetHeight);
		this.s.style.width=px(w-this.sw.offsetWidth-this.se.offsetWidth);
		this.se.style.top=px(this.ne.offsetHeight+this.w.offsetHeight);
		this.se.style.left=px(this.sw.offsetWidth+this.s.offsetWidth);
		this.mask.style.top=px(this.n.offsetHeight);
		this.mask.style.height=px(h-this.n.offsetHeight);
	}
	
	
	this.active=function(){
		if(!window.curWin){window.curWin=this}; 
		if(window.curWin==this){
			$(this.WIN).removeClass('deactive');
			$(this.mask).hide();
			return;
		}
		if(window.curWin.modal&&this.WIN.style.zIndex!=this.container.maxIndex)return;
		$(window.curWin.mask).show();
		$(window.curWin.WIN).addClass('deactive');
		$(this.WIN).removeClass('deactive');
		$(this.mask).hide();
		this.container.maxIndex++;
		this.WIN.style.zIndex=this.container.maxIndex;
		this.preWin=window.curWin;
		window.curWin=this;	
	}
	

	this.closeWin=function(){
		if(window.curWin.modal&&window.curWin!=this)return;
		$('#modalwindowsbg').removeClass('opaque');
		$(this.WIN).remove();
		window.curWin=null;
		if(this.preWin){this.preWin.active();}
		if(this.container.childNodes.length==0){$(this.container.parentNode).hide();}
	}

	this.maxWin=function(){
		$(this.maxbutton).toggleClass('restore');
		if(this.orignalWidth&&this.orignalHeight){			
			this.WIN.style.width=px(this.orignalWidth);
			this.WIN.style.height=px(this.orignalHeight);
			this.WIN.style.left=px(this.orignalLeft);
			this.WIN.style.top=px(this.orignalTop);
			this.resize();
			this.orignalWidth=this.orignalHeight=this.orignalLeft=this.orignalTop=null;
		}
		else{
			this.orignalWidth=this.WIN.offsetWidth;
			this.orignalHeight=this.WIN.offsetHeight;
			this.orignalLeft=this.WIN.offsetLeft;
			this.orignalTop=this.WIN.offsetTop;
			this.WIN.style.width=px($("body").width());
			this.WIN.style.height=px($("body").height());
			this.WIN.style.left=this.WIN.style.top="0px";
			this.resize();
		}
	}

	this.move=function(l,t){
		if(!l&&!t){
			w=this.WIN.offsetWidth;
			h=this.WIN.offsetHeight;
			l=($("body").width()-w)/2;
			t=($("body").height()-h)/2;
		}
		this.WIN.style.top=px(t);
		this.WIN.style.left=px(l);
	};
	
	this.autoresize=function(w,h){
		var _t=this.WIN.offsetTop;
		var _h=this.WIN.offsetHeight;
		var _l=this.WIN.offsetLeft;
		var _w=this.WIN.offsetWidth;		
		var bh=window.document.body.offsetHeight;
		var bw=window.document.body.offsetWidth;
		var win=this;
		$(this.content).load(function(){
			var w=this.document.body.scrollWidth;
			var h=this.document.body.scrollHeight;
			if(_t+h>bh)h=bh-_t; 
			if(_l+w>bw)w=bw-_l;
			w=w-win.w.offsetWidth-win.w.offsetWidth;
			h=h-win.n.offsetHeight-win.s.offsetHeight;
			win.resize(w, h);;
		});
	};
	
	this.showWin=function(){
		this.WIN.style.visibility="visible";
	}

	
	this.hideWin=function(){
		this.WIN.style.visibility="hidden";
	}
	
	this.setTitle=function(t){
        	this.n.innerHTML=t;
        	this.title=t;
	}
	

	this.init();

}	