﻿window.urlpath=(window.location.protocol+"//"+window.location.host+window.location.pathname).replace("index.html","");//域名或ip地址
window.remoteDataUrl=window.urlpath;//系统数据目录


$(function(){
	loadNASinfo();
	layout();	
	bindEvent();
	loadsponsors();
});


function layout(){	
		window.onload=window.onresize=function(){
			var h=document.documentElement.offsetHeight;
			var l=document.getElementById("login");
			var b=document.getElementById("bottom");
			var lh=l.offsetHeight;
			l.style.top=px((h-lh)/2-50); 
			
			var t=l.offsetTop+l.offsetHeight;
			b.style.top=px(t);
		}
}

function  bindEvent(){
	document.getElementById('username').focus();
	if(getRequest('lang')&&getRequest('lang')!="")window.Lang=getRequest('lang').replace('_','-').toLowerCase();	
	

	
	var lastuser=getCookie('lastuser');
	if(lastuser){
		$("#rememberme").attr('checked','checked');
		var userdata=$.parseJSON(lastuser);
		$("#username").val(userdata.name);
		$("#lang option:[value='"+userdata.language+"']").attr("selected","selected");
		loadLang($("#lang").val());
	}
	else{
		loadLang();
		$("#lang option[value='"+window.Lang+"']").attr("selected","selected");
	}

	
	//设置语言
	$("#lang").change(function(){
		setLang({app:window.App,lang:this.value});
		loadsponsors();
	});	
	
	//添加登录按钮事件
	$("#OK").click(function(){ getNonceString();return false; });
	$("#username, #mangled_password").keypress(function(e){
		if(e.which==13)$("#OK").click();
	});
}


function loadsponsors(){
	$.ajax({
		url: 'Sponsors/'+window.Lang.toLowerCase()+'.xml'
		,type: "GET"
		,cache:false
		,dataType:"xml"
		,success: function(data){
				parsesponsors(data);
		}
		,error:function(data){
		}
	});
}

function parsesponsors(data){
	var sponsors=$('sponsor',data);
	if(sponsors.length>0){
		$('#sponsoralabel').show();
		$('#sponsors').empty();
		$('sponsor',data).each(function(){
			$('#sponsors').append('<a href="'+$('link',this).text()+'" title="'+$('name',this).text()+'" target="_blank" class="sponsor"><img src="Sponsors/logos/'+$('logo',this).text()+'"/></a>');
		});
	}
}


function loadNASinfo(){
	$.getScript('nas/get/register?output=json&callback=loadVpnNASinfo'); 
}


function loadVpnNASinfo(json){	
	if(json.ipaddr!==window.location.host&&json.upnpaddr!==window.location.host&&json.ipaddr!==window.location.hostname+':80'&&json.upnpaddr!==window.location.hostname+':80'){
		window.NASinfo=json;
		var local = window.open('','local').document;
		var upnp = window.open('','upnp').document;
		if(json.ipaddr!=='')local.write('<script type="text/javascript" src="http://'+json.ipaddr+'/nas/get/register?output=json&callback=window.top.TryLocalAddr" ></'+'script>');
		if(json.upnpaddr!=='')upnp.write('<script type="text/javascript" src="http://'+json.upnpaddr+'/nas/get/register?output=json&callback=window.top.TryUPnpAddr" ></'+'script>');
	}
}

function TryLocalAddr(json){
	if(json.register===window.NASinfo.register)window.open("http://"+window.NASinfo.ipaddr+'/','_top');
}

function TryUPnpAddr(json){
	if(json.register===window.NASinfo.register)window.open("http://"+window.NASinfo.upnpaddr+'/','_top');
}



//--------------------------------登录-------------------------------------------------------------
function login(hash,modulus,public){
	var pass=Crypt($("#mangled_password").val(),modulus,public);
	$.ajax({
		url: remoteDataUrl+"nas/login"
		,cache:false
		,data:{
			user:$("#username").val()
			,pass:pass
			,hash:hash
			,lang:window.Lang
		}
		,cache:false
		,type: "POST"
		,dataType:"xml"		
		,success: function(data){
			if(checkAPIError(data)){$("#waiting").hide();return;}
			var privilege = ($("#username").val()=='admin')?0:1;
			var ip = $("ipaddr:first",data).text();
			var SessionID = hash;
			if($("#username").val()=='admin')privilege='0';
			if($("#rememberme").attr('checked')) setLoginCookies();
			else delLoginCookies();
			//setCookie('session',SessionID); 
			//var platform=navigator.platform;
			//if(platform=="iPhone")
			window.open(window.urlpath+'Applications/System/os.html?lang='+window.Lang+'&id='+SessionID+'&remoteDataUrl='+window.remoteDataUrl+"&user="+$("#username").val()+"&privilege="+privilege+'&modulus='+modulus+'&public='+public+'&','_self'); 
			
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}


//--------------------------------获取登录验证码------------------------------------------------
function getNonceString(){
	if(!validate())return;
	$("#waiting").show();
	$.ajax({
		url: remoteDataUrl+"nas/gen/hash"
		,data:{time:new Date()}
		,type: "POST"
		,cache:false
		,dataType:"xml"
		,success: function(data){ 
			//get nonce.			
			var hash=$(data).find("hash").text();
			var modulus=$(data).find("modulus").text();	
			var public=$(data).find("public").text();
			login(hash,modulus,public);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ($.l10n.__("global_alert_getdataerror"));
		}
		//,timeout:20000
	});
}


function validate(){
	var n=$("#username").val().replace(/\s/g,"");
	var p=$("#mangled_password").val().replace(/\s/g,"");
	if(n==""||p==""){
		alert( $.l10n.__("global_alert_inputerror"));
		return false;
	}
	return true;
}



function setLoginCookies(){
	var userdata={
		name: $('#username').val()
		,language: window.Lang
	};
	userdata=$.toJSON(userdata);
	setCookie('lastuser',userdata);
}


function delLoginCookies(){
	delCookie('lastuser');
}