$(function(){	
	window.App="AlbumMaker";
	layout();
	loadLang();
	loadData();
	bindEvent();
});


function bindEvent(){
	$("#noshare").click(function(){
		showNoShare();
	});
	
	
	$("#share").click(function(){
		showShare();
	});
	
	$("#publish").click(function(){
		showPublish();
	});
	
	$("#APPLY").click(function(){		
		APPLY();
	});
	
	$("#CANCEL").click(function(){		
		window.win.closeWin();
	});
}


function layout(){
	$("#users").append("<table id='userlist'></table");
	$("#userlist").flexigrid({
		singleSelect:true
		,colModel : [
				 {display: '', name : 'check', width : 12, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="global_text_username"></label>', name : 'username', width : 90, sortable : false, align: 'left'}
				]
		});
	$('.flexigrid div.bDiv').height($('.flexigrid').height()-$('.flexigrid div.hDiv').height());
	window.$refreshNode = window.top.$('#App_AlbumMaker_Win_AlbumMaker #ALBUM li.REFRESH');
}



function loadData(){
	window.$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/users"
		,cache:false
		,type: "POST"
		,data: {
			hash:window.top.SessionID
			,date:new Date()
		}
		,dataType: "xml"
		,success: function(data){
			window.$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			$("name",data).each(function (){		
				var name=$(this).text();
				if(name!=window.top.user){
					$("#userlist")[0].grid.addRow({
						id:name
						,check:"<input type='checkbox'/>"
						,username:name
					});
				}
			});
			showShareinfo();
	}
	,error: function(data) {
		window.$("#waiting").hide();
		alert ($.l10n.__("global_alert_getdataerror")); 
	}
	//,timeout: 20000
	});
}



function showShareinfo(){
	var o=window.win.fromWinObject; 
	$("#path").html(o.path);
	 if(o.shared=='shared'){
		$("#share").click();
		$(o.info).each(function (){
			var username=$(this).text(); 
			var $TR=$("#userlist tr#"+username);
			$("input:checkbox",$TR).attr('checked','checked');
		});
	}
	else if(o.shared=='published'){
		$("#publish").click();	
	}
	else{
		 $("#noshare").click();
	}
}

function showNoShare(){
	$("#users input").attr("disabled","disabled");
}

function showShare(){
	$("#users input").attr("disabled","");
}

function showPublish(){
	$("#users input").attr("disabled","disabled");
}

function APPLY(){
	switch($("input:radio:checked")[0].id){
		case "noshare":
				toDelete();
			break;
		case "share":
				toEdit();
			break
		case "publish":
				toPublish();
			break
	}
}



function toValidate(){
	var checkboxs=$("#userlist input:checkbox:checked");
	if(checkboxs.length==0){
		alert($.l10n.__('AlbumMaker_share_alert_atleastoneuser'));
		return false;
	}
	window.sharers="";
	window.sharerxml='<?xml version="1.0" encoding="utf-8"?><sharers  xmlns:R="works">'
	for(var i=0;i<checkboxs.length;i++){
		var tr=checkboxs[i].parentNode.parentNode.parentNode;
		window.sharers += "&sharer="+ encodeURI(tr.id);
		window.sharerxml += '<sharer>'+encodeURI(tr.id)+'</sharer>';
	}
	window.sharerxml+='</sharers>';
	return true;
}



function toPublish(){
	$("#waiting").show();	
	$.ajax({
	   url: window.top.remoteDataUrl+"nas/edit/album"
	   ,cache:false
	   ,type: "POST"
	   ,data: {
		   hash:window.top.SessionID
		   ,name:$("#path").html()
		   ,sharer:"*"
		 }
	   ,dataType: "xml"
	   ,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;	
			if(window.top.AlbumMaker)window.top.AlbumMaker.refreshWin('/dav/albums','published');
			if(window.win.fromWinObject.fn)window.win.fromWinObject.fn.apply();
		}
	   ,error: function(data) { 		   
			$("#waiting").hide();
			alert ($.l10n.__("global_alert_getdataerror"));
		}
		//timeout:20000
	});	
	
}



function toEdit(){
	if(!toValidate())return;
	$("#waiting").show();
	$.ajax({
	   url: window.top.remoteDataUrl+"nas/edit/album"
	   ,type: "POST"
	   ,cache:false
	   ,data: 
			"hash="+ encodeURI(window.top.SessionID)
		   +"&name="+ encodeURI($("#path").html())
		   + window.sharers
	   ,dataType: "xml"
	   ,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			if(window.top.AlbumMaker)window.top.AlbumMaker.refreshWin('/dav/albums','shared');
			if(window.win.fromWinObject.fn)window.win.fromWinObject.fn.apply();
		}
	   ,error: function(data) { 		   
			$("#waiting").hide();
			alert ($.l10n.__("global_alert_getdataerror"));
		}
		//timeout:20000
	});
}


function toDelete(){
	$("#waiting").show();	
	$.ajax({
	   url: window.top.remoteDataUrl+"nas/edit/album"
	   ,type: "POST"
	   ,cache:false
	   ,data: {
		   hash:window.top.SessionID
		   ,name:$("#path").html()
		   ,sharer:""
		 }
	   ,dataType: "xml"
	   ,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			window.isShared=false;
			if(window.top.AlbumMaker)window.top.AlbumMaker.refreshWin('/dav/albums','null');
			if(window.win.fromWinObject.fn)window.win.fromWinObject.fn.apply();
			
		}
	   ,error: function(data) {
			$("#waiting").hide();
			alert ($.l10n.__("global_alert_getdataerror")); 
		}
		//timeout:20000
	});
	
	
}
